/*****************************************************************-*- c++ -*-*
  Be FileTypes and Attributes extention for Ruby , [be_stat] by tenmei
*****************************************************************************/
#define __BE_STAT_MAIN_CPP__
/*****************************************************************************
  INCLUDES
*****************************************************************************/
#include <Be.h>

#include "ruby.h"

#include "be_attr.h"

/*****************************************************************************
  DEFINES
*****************************************************************************/

/*****************************************************************************
  TYPES
*****************************************************************************/

/*****************************************************************************
  PROTOTYPES
*****************************************************************************/

/*****************************************************************************
  EXTERNAL WORKS
*****************************************************************************/

/*****************************************************************************
  LOCAL WORKS
*****************************************************************************/

/*****************************************************************************
  PROCEDURES
*****************************************************************************/
extern "C" {

void Init_be_stat(void )
{
    /*
     * BeStat module.
     * as namespace of follow class/modules.
     */
    VALUE BeStatVALUE = rb_define_module("BeStat");
    
    /*
     * Be Data Type constants.
     * See BeBook SupportKit `Constants and Defined Types'.
     */
    rb_define_const(BeStatVALUE,"B_ANY_TYPE",UINT2NUM(B_ANY_TYPE));
    rb_define_const(BeStatVALUE,"B_BOOL_TYPE",UINT2NUM(B_BOOL_TYPE));
    rb_define_const(BeStatVALUE,"B_CHAR_TYPE",UINT2NUM(B_CHAR_TYPE));
    rb_define_const(BeStatVALUE,"B_COLOR_8_BIT_TYPE",
                    UINT2NUM(B_COLOR_8_BIT_TYPE));
    rb_define_const(BeStatVALUE,"B_DOUBLE_TYPE",UINT2NUM(B_DOUBLE_TYPE));
    rb_define_const(BeStatVALUE,"B_FLOAT_TYPE",UINT2NUM(B_FLOAT_TYPE));
    rb_define_const(BeStatVALUE,"B_GRAYSCALE_8_BIT_TYPE",
                    UINT2NUM(B_GRAYSCALE_8_BIT_TYPE));
    rb_define_const(BeStatVALUE,"B_INT64_TYPE",UINT2NUM(B_INT64_TYPE));
    rb_define_const(BeStatVALUE,"B_INT32_TYPE",UINT2NUM(B_INT32_TYPE));
    rb_define_const(BeStatVALUE,"B_INT16_TYPE",UINT2NUM(B_INT16_TYPE));
    rb_define_const(BeStatVALUE,"B_INT8_TYPE",UINT2NUM(B_INT8_TYPE));
    rb_define_const(BeStatVALUE,"B_MESSAGE_TYPE",UINT2NUM(B_MESSAGE_TYPE));
    rb_define_const(BeStatVALUE,"B_MESSENGER_TYPE",UINT2NUM(B_MESSENGER_TYPE));
    rb_define_const(BeStatVALUE,"B_MIME_TYPE",UINT2NUM(B_MIME_TYPE));
    rb_define_const(BeStatVALUE,"B_MONOCHROME_1_BIT_TYPE",
                    UINT2NUM(B_MONOCHROME_1_BIT_TYPE));
    rb_define_const(BeStatVALUE,"B_OBJECT_TYPE",UINT2NUM(B_OBJECT_TYPE));
    rb_define_const(BeStatVALUE,"B_OFF_T_TYPE",UINT2NUM(B_OFF_T_TYPE));
    rb_define_const(BeStatVALUE,"B_PATTERN_TYPE",UINT2NUM(B_PATTERN_TYPE));
    rb_define_const(BeStatVALUE,"B_POINTER_TYPE",UINT2NUM(B_POINTER_TYPE));
    rb_define_const(BeStatVALUE,"B_POINT_TYPE",UINT2NUM(B_POINT_TYPE));
    rb_define_const(BeStatVALUE,"B_RAW_TYPE",UINT2NUM(B_RAW_TYPE));
    rb_define_const(BeStatVALUE,"B_RECT_TYPE",UINT2NUM(B_RECT_TYPE));
    rb_define_const(BeStatVALUE,"B_REF_TYPE",UINT2NUM(B_REF_TYPE));
    rb_define_const(BeStatVALUE,"B_RGB_32_BIT_TYPE",
                    UINT2NUM(B_RGB_32_BIT_TYPE));
    rb_define_const(BeStatVALUE,"B_RGB_COLOR_TYPE",UINT2NUM(B_RGB_COLOR_TYPE));
    rb_define_const(BeStatVALUE,"B_SIZE_T_TYPE",UINT2NUM(B_SIZE_T_TYPE));
    rb_define_const(BeStatVALUE,"B_SSIZE_T_TYPE",UINT2NUM(B_SSIZE_T_TYPE));
    rb_define_const(BeStatVALUE,"B_STRING_TYPE",UINT2NUM(B_STRING_TYPE));
    rb_define_const(BeStatVALUE,"B_TIME_TYPE",UINT2NUM(B_TIME_TYPE));
    rb_define_const(BeStatVALUE,"B_UINT64_TYPE",UINT2NUM(B_UINT64_TYPE));
    rb_define_const(BeStatVALUE,"B_UINT32_TYPE",UINT2NUM(B_UINT32_TYPE));
    rb_define_const(BeStatVALUE,"B_UINT16_TYPE",UINT2NUM(B_UINT16_TYPE));
    rb_define_const(BeStatVALUE,"B_UINT8_TYPE",UINT2NUM(B_UINT8_TYPE));
    rb_define_const(BeStatVALUE,"B_MEDIA_PARAMETER_TYPE",
                    UINT2NUM(B_MEDIA_PARAMETER_TYPE));
    rb_define_const(BeStatVALUE,"B_MEDIA_PARAMETER_WEB_TYPE",
                    UINT2NUM(B_MEDIA_PARAMETER_WEB_TYPE));
    rb_define_const(BeStatVALUE,"B_MEDIA_PARAMETER_GROUP_TYPE",
                    UINT2NUM(B_MEDIA_PARAMETER_GROUP_TYPE));
    
    /*
     * Be Attribute class.
     * See BeBook StorageKit `BNode' and `BNodeInfo'.
     */
    ::rb_be_attr::init(BeStatVALUE);
    
}

} // extern "C"

/*****************************************************************************
  END OF FILE
*****************************************************************************/
